(function() {
  var Channel, Logger, Telegram, fs, request, util,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  fs = require('fs');

  util = require('util');

  request = require('request');

  Channel = require('./channel').Channel;

  Logger = require('./logger').Logger;

  Telegram = (function(superClass) {
    extend(Telegram, superClass);

    function Telegram(params) {
      Telegram.__super__.constructor.call(this, {
        homedir: params.homedir,
        uid: params.uid,
        platform: 'telegram'
      });
    }

    Telegram.prototype.execute = function(body, parameters, handler) {
      var uid;
      uid = this.params.uid;
      return new Promise((function(_this) {
        return function(resolve, reject) {
          return Logger.init(_this.params).then(function(logger) {
            var supportedMethods;
            logger.incoming(body);
            supportedMethods = ["message", "photo", "audio", "document", "location", "venue", "contact"];
            if (!body.message) {
              return resolve();
            } else {
              return handler(uid, body, 'telegram', function(data) {
                var method, options, uri;
                method = "sendMessage";
                if (data.type && supportedMethods.indexOf(data.type.toLowerCase()) >= 0) {
                  method = data.type.toLowerCase();
                  method = util.format("send%s%s", method.substr(0, 1).toUpperCase(), method.substr(1, method.length - 1));
                }
                uri = util.format("https://api.telegram.org/bot%s/%s", process.env.TELEGRAM_ACCESS_TOKEN || process.env.RECIME_TELEGRAM_ACCESS_TOKEN, method);
                options = {
                  uri: uri,
                  method: 'POST'
                };
                if (data.payload) {
                  options.json = data.payload;
                } else {
                  options.json = data;
                }
                if (body.message) {
                  options.json.chat_id = body.message.chat.id;
                }
                return request(options, function(err, response, result) {
                  var message;
                  logger.outgoing(options, result);
                  if (!err && response.statusCode === 200) {
                    return resolve();
                  } else {
                    message = {
                      message: {
                        text: JSON.stringify(result.error || response.body),
                        chat_id: options.json.chat_id
                      }
                    };
                    return resolve(message);
                  }
                });
              }, function(err) {
                return resolve(err);
              });
            }
          });
        };
      })(this));
    };

    return Telegram;

  })(Channel);

  module.exports = Telegram;

}).call(this);
