fs = require('fs')
util = require('util')
request = require('request')

Channel = require('./channel').Channel

Logger = require('./logger').Logger

class Telegram extends Channel
    constructor:(params)->
        super
            homedir : params.homedir
            uid : params.uid
            platform : 'telegram'

    execute:(body, parameters, handler)->
        uid = @params.uid   

        new Promise (resolve, reject)=>
            Logger.init(@params).then (logger)=>
                logger.incoming(body);
      
                supportedMethods = [
                    "message",
                    "photo",
                    "audio"
                    "document",
                    "location",
                    "venue",
                    "contact"
                ]

                if !body.message
                    resolve()
                else
                    handler uid, body, 'telegram', (data)->
                        method = "sendMessage"

                     
                        if data.type and supportedMethods.indexOf(data.type.toLowerCase()) >= 0
                            method = data.type.toLowerCase()
                            method = util.format("send%s%s", method.substr(0, 1).toUpperCase(), method.substr(1, method.length - 1))
                        
                        uri = util.format("https://api.telegram.org/bot%s/%s", process.env.TELEGRAM_ACCESS_TOKEN || process.env.RECIME_TELEGRAM_ACCESS_TOKEN, method)

                        options =
                            uri : uri
                            method : 'POST'

                        if data.payload
                            options.json = data.payload
                        else
                            options.json = data

                        if body.message
                            options.json.chat_id  = body.message.chat.id

                        request options, (err, response, result)->
                            logger.outgoing(options, result)
                            
                            if  !err and response.statusCode is 200
                                resolve()
                            else
                                message =
                                    message :
                                        text: JSON.stringify(result.error || response.body)
                                        chat_id : options.json.chat_id
                                resolve(message)
                    , (err)->
                        resolve(err)


module.exports = Telegram
